%%
country = 'Kazakhstan';
[yData Date] = getCountryData( country, 2 );

yData = yData(51:277,:);
Date = Date(51:277,:);

startDate = 1;
dateRange = (1:length( yData(:,1)))-1+startDate;
dateRange = datenum(Date);
date7Days = dateRange(1):15:dateRange(end);

figure;
subplot(1, 2, 1); 
patch([737864 737972 737972 737864], [0 0 3.5e4 3.5e4], [0.8 0.8 0.8], 'FaceAlpha', 0.5, 'LineStyle', 'none'); hold on;
plot( dateRange , movmean(yData(:,1) - yData(:,3), 7), '.', 'Markersize', 15 );
ylabel('Active Confirmed Cases');
xlabel('Date'); 

set(gca, 'XTick', datenum(date7Days));
datetick('x', 'dd-mmm-yy', 'keepticks');
xtickangle(90);
axis([dateRange(1) dateRange(end) 0 3.5e4]);
grid;
subplot(1, 2, 2); 
patch([737864 737972 737972 737864], [0 0 2000 2000], [0.8 0.8 0.8], 'FaceAlpha', 0.5, 'LineStyle', 'none'); hold on;
plot( dateRange , yData(:,2), '.', 'Color', colour(2,:), 'Markersize', 15 );
ylabel('Confirmed Deaths');
xlabel('Date');

set(gca, 'XTick', datenum(date7Days));
datetick('x', 'dd-mmm-yy', 'keepticks');
xtickangle(90);
axis([dateRange(1) dateRange(end) 0 2000]);
grid;

%%
figure;
set( gcf, 'Position', [1         233        1690         747] );

subplot( 1, 2, 1 ); hold on;
h(1) = plot( (1:length( yData(:,1)))-1+startDate, movmean(yData(:,1) - yData(:,3) - yData(:,2), 7), '.', 'Linewidth', 1, 'Markersize', 18 );

subplot( 1, 2, 2 ); hold on;
g(1) = plot( (1:length( yData(:,1)))-1+startDate, yData(:,2), 'o', 'Linewidth', 1, 'Color', colour(2,:), 'Markersize', 8 );

%%
firstCase= 0;
N        = 18.8e6;
oldPop   = 0.08;
dRate    = 0.015;
dOldRate = 0.03;

D_init = 0;
R_init = 0;
I_init = 5;
E_init = 20*I_init;
S_init = N - I_init - E_init - D_init - R_init;
alpha = 1/5.1;
gamma = 1/18.8;
delta = 1/18.8;
phi = delta * ( (1 - (1 - dOldRate) )*oldPop + (1 - (1 - dRate) )*(1 - oldPop) );

finalEndTime = 300;
modelI = [];
modelD = [];
timeI = [];
timeD = [];
ii = 1; % plotCount

beta = 0.2;
R_0 = beta / (gamma + phi);
yMax = 55e3;
endTime = 50;
startTime = 0;
R(ii) = R_0;

sigma = 0.15;
tau_sigmapre = 25;
tau_sigmapost = 0;
ii = ii + 1;

[outEndTime h(ii) g(ii) mI tI mD tD] = contActFit( startDate, S_init, E_init, I_init, R_init, D_init, ...
    oldPop, N, startTime, endTime, gamma, alpha, phi, delta, R_0, '-', ...
    1, firstCase, sigma, tau_sigmapre, tau_sigmapost );

R_0 = R_0 * (1 - sigma);
R(ii) = R_0;
sigmaOut(ii) = sigma;
sigmaRatioOut(ii) = sigma;
dayOut(ii) = tau_sigmapre + tau_sigmapost;

modelI = [modelI; mI];
modelD = [modelD; mD];
timeI = [timeI; tI];
timeD = [timeD; tD];

%%
dayOut(ii+1) = endTime;
startTime = endTime + startTime - 1;
endTime = 52;
endTime = endTime - startTime;


sigma = 0.2975;
ii = ii + 1;
sigmaOut(ii) = sigma;
sigmaRatio = 1 - (1 - sum(sigmaOut)) / prod(1 - sigmaRatioOut(1:end));
tau_sigmapre = 0;
tau_sigmapost = 0;

[outEndTime h(ii) g(ii) mI tI mD tD] = contActFit( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '-', 1, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );

R_0 = R(1) * (1 - sum(sigmaOut));
R(ii) = R_0;
sigmaRatioOut(ii) = sigmaRatio;

modelI = [modelI; mI];
modelD = [modelD; mD];
timeI = [timeI; tI];
timeD = [timeD; tD];

%%
dayOut(ii+1) = endTime + startTime;
startTime = endTime + startTime - 1;
endTime = 63 - startTime;

sigma = 0.3923;
ii = ii + 1;
sigmaOut(ii) = sigma;
sigmaRatio = 1 - (1 - sum(sigmaOut)) / prod(1 - sigmaRatioOut(1:end));
tau_sigmapre = 0;
tau_sigmapost = 0;

[outEndTime h(ii) g(ii) mI tI mD tD] = contActFit( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '-', 1, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );

R_0 = R(1) * (1 - sum(sigmaOut));
R(ii) = R_0;
sigmaRatioOut(ii) = sigmaRatio;

modelI = [modelI; mI];
modelD = [modelD; mD];
timeI = [timeI; tI];
timeD = [timeD; tD];

%%
dayOut(ii+1) = endTime + startTime;
startTime = endTime + startTime - 1;
endTime = 79 - startTime;

sigma = -0.4807;
ii = ii + 1;
sigmaOut(ii) = sigma;
sigmaRatio = 1 - (1 - sum(sigmaOut)) / prod(1 - sigmaRatioOut(1:end));
tau_sigmapre = 0;
tau_sigmapost = 0;

[outEndTime h(ii) g(ii) mI tI mD tD] = contActFit( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '-', 1, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );

R_0 = R(1) * (1 - sum(sigmaOut));
R(ii) = R_0;
sigmaRatioOut(ii) = sigmaRatio;

modelI = [modelI; mI];
modelD = [modelD; mD];
timeI = [timeI; tI];
timeD = [timeD; tD];

%%
dayOut(ii+1) = endTime + startTime;
startTime = endTime + startTime - 1;
endTime = 88 - startTime;

sigma = 0.5448;
ii = ii + 1;
sigmaOut(ii) = sigma;
sigmaRatio = 1 - (1 - sum(sigmaOut)) / prod(1 - sigmaRatioOut(1:end));
tau_sigmapre = 0;
tau_sigmapost = 0;

[outEndTime h(ii) g(ii) mI tI mD tD] = contActFit( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '-', 1, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );

R_0 = R(1) * (1 - sum(sigmaOut));
R(ii) = R_0;
sigmaRatioOut(ii) = sigmaRatio;

modelI = [modelI; mI];
modelD = [modelD; mD];
timeI = [timeI; tI];
timeD = [timeD; tD];

%%
dayOut(ii+1) = endTime + startTime;
startTime = endTime + startTime - 1;
endTime = 105 - startTime;

sigma = -0.4038;
ii = ii + 1;
sigmaOut(ii) = sigma;
sigmaRatio = 1 - (1 - sum(sigmaOut)) / prod(1 - sigmaRatioOut(1:end));
tau_sigmapre = 0;
tau_sigmapost = 0;

[outEndTime h(ii) g(ii) mI tI mD tD] = contActFit( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '-', 1, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );

R_0 = R(1) * (1 - sum(sigmaOut));
R(ii) = R_0;
sigmaRatioOut(ii) = sigmaRatio;

modelI = [modelI; mI];
modelD = [modelD; mD];
timeI = [timeI; tI];
timeD = [timeD; tD];

%%
dayOut(ii+1) = endTime + startTime;
startTime = endTime + startTime - 1;
endTime = 116 - startTime;

sigma = -0.22;
ii = ii + 1;
sigmaOut(ii) = sigma;
sigmaRatio = 1 - (1 - sum(sigmaOut)) / prod(1 - sigmaRatioOut(1:end));
tau_sigmapre = 0;
tau_sigmapost = 0;

[outEndTime h(ii) g(ii) mI tI mD tD] = contActFit( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '-', 1, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );

R_0 = R(1) * (1 - sum(sigmaOut));
R(ii) = R_0;
sigmaRatioOut(ii) = sigmaRatio;

modelI = [modelI; mI];
modelD = [modelD; mD];
timeI = [timeI; tI];
timeD = [timeD; tD];

%%
dayOut(ii+1) = endTime + startTime;
startTime = endTime + startTime - 1;
endTime = finalEndTime - startTime;
finalSigma = 0.5831;

sigma = 0;
ii = ii + 1;
sigmaOut(ii) = sigma;
sigmaRatio = 1 - (1 - sum(sigmaOut)) / prod(1 - sigmaRatioOut(1:end));
tau_sigmapre = 0;
tau_sigmapost = 0;

[outEndTime1 h(ii) g(ii) mI tI mD tD] = contActPred( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '-', 1, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );


sigma = finalSigma;
ii = ii + 1;
sigmaOut(ii) = sigma;
sigmaRatio = 1 - (1 - sum(sigmaOut)) / prod(1 - sigmaRatioOut(1:end));
tau_sigmapre = 0;
tau_sigmapost = 0;
ii = ii + 2;

modelI = [modelI; mI];
modelD = [modelD; mD];
timeI = [timeI; tI];
timeD = [timeD; tD];

[outEndTime1 h(ii) g(ii)] = contActPred( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '--', 2, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );


sigma = finalSigma;
tau_sigmapre = 0;
tau_sigmapost = 7;
ii = ii + 2;

[outEndTime1 h(ii) g(ii)] = contActPred( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, ':', 3, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );


sigma = finalSigma;
tau_sigmapre = 0;
tau_sigmapost = 14;
ii = ii + 2;

[outEndTime1 h(ii) g(ii)] = contActPred( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '-.', 4, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );

sigma = finalSigma;
tau_sigmapre = 0;
tau_sigmapost = 21;
ii = ii + 2;

[outEndTime1 h(ii) g(ii)] = contActPred( startDate, outEndTime(1), outEndTime(2), outEndTime(3), outEndTime(4), ...
    outEndTime(5), oldPop, N, startTime, endTime, gamma, ...
    alpha, phi, delta, R_0, '--', 5, firstCase, sigmaRatio, tau_sigmapre, tau_sigmapost );

R_0 = R(1) * (1 - sum(sigmaOut));
R(ii-9) = R_0;
sigmaOut(ii-9) = sigma;
sigmaOut = sigmaOut(1:end-1);
dayOut(ii-8) = endTime + startTime;
dayOut = dayOut(1:end-1);
sigmaRatioOut(ii-9) = sigmaRatio;
sigmaEff = cumsum(sigmaOut);

%%
R = round( R * 100 ) / 100;
sigmaOut = round( sigmaOut * 100 ) / 100;
sigmaRatioOut = round( sigmaRatioOut * 100 ) / 100;
sigmaEff = round( sigmaEff * 100 ) / 100;
outR = table( dayOut', sigmaOut', sigmaEff', R', 'VariableNames', {'Day' 'sigma' 'sigma_eff' 'R'} )

%%
subplot1 = subplot( 1, 2, 1 ); hold off;
ylim( [0 yMax] );
yHi = ylim;
yHi = yHi( 2 );

% timestmpInf;

xlim( [startDate+3 endTime+startTime+startDate] );
leg = legend( [h(1) h(9) h(12) h(14) h(16) h(18)], {'Actual data',...
    'Model (without control action)',...
    'Model (Control action Scenario #1)',...
    'Model (Control action Scenario #2)',...
    'Model (Control action Scenario #3)',...
    'Model (Control action Scenario #4)'},...
    'Location', 'SouthOutside');
leg.FontSize = 12;
ylabel( 'Active Confirmed Cases' );
xlabel( 'Days' );

%%
subplot2 = subplot( 1, 2, 2 ); hold off;
ylim( [0 5000] );
xlim( [startDate+3 endTime+startTime+startDate] );
yHi = ylim;
yHi = yHi( 2 );

% timestmpDeath;

leg = legend( [g(1) g(9) g(12) g(14) g(16) g(18)], {'Actual data',...
    'Model (without control action)',...
    'Model (Control action Scenario #1)',...
    'Model (Control action Scenario #2)',...
    'Model (Control action Scenario #3)',...
    'Model (Control action Scenario #4)'},...
    'Location', 'SouthOutside' );
leg.FontSize = 12;
ylabel( 'Cumulative Deaths' );
xlabel( 'Days' );

%% EOL
