function [outEndTime h g mI tI mD tD] = contActKZ( startDate, S_init,...
   E_init, I_init, R_init, D_init, oldPop, N, startTime, endTime, gamma,...
   alpha, phi, delta, R_0, varargin )

beta = R_0*(gamma+phi);
lineStyle = '-';
lineColour = 1;

optIn = length( varargin );
firstCase = 0;
sigma = 0;
tau_sigmapre = 0;
tau_sigmapost = 0;
xi = 0;
tau_xi = 0;

if optIn > 0
    lineStyle = varargin{1};
end
if optIn > 1
    lineColour = varargin{2};
end
if optIn > 2
    firstCase = varargin{3};
end
if optIn > 3
    sigma = varargin{4};
end
if optIn > 4
    tau_sigmapre = varargin{5} - firstCase;
end
if optIn > 5
    tau_sigmapost = varargin{6} - firstCase;
end
if optIn > 6
    xi = varargin{7};
end
if optIn > 7
    tau_xi = varargin{8} - firstCase;
end

options = simset('SrcWorkspace','current');
load_system( 'COVID_mod.mdl' );
out = sim( 'COVID_mod.mdl', endTime, options );
close_system( 'COVID_mod.mdl' );

outEndTime = [out.S.Data(endTime) out.E.Data(endTime) out.I.Data(endTime) out.R.Data(endTime)...
    out.D.Data(endTime)];

colour = get( gca, 'ColorOrder' );

subplot( 1, 2, 1 );
h = plot( out.I.Time(1:endTime)+startTime+firstCase+startDate, [(out.I.Data(1:endTime))], ...
    'Color', colour(1,:), 'Linewidth', 1, 'Linestyle', lineStyle );

subplot( 1, 2, 2 );
g = plot( out.D.Time(1:endTime)+startTime+firstCase+startDate, out.D.Data(1:endTime), ...
    'Color', colour(2,:), 'Linewidth', 1, 'Linestyle', lineStyle );

mI = out.I.Data(1:endTime);
tI = out.I.Time(1:endTime)+startTime+firstCase+startDate;
mD = out.D.Data(1:endTime);
tD = out.D.Time(1:endTime)+startTime+firstCase+startDate;
