function F = covidNonlinearMdl( b,tSpan, init, popData, flag )

N = popData(1);
NOld = popData(2);

alpha = b(1);
beta  = b(2);
gamma = b(3);
delta = b(4);
kappa = b(5);
kappaOld = b(6);
S0 = init(1);
E0 = init(2);
I0 = init(3);
R0 = init(4);
D0 = init(5);

nonlinearFun = @(t,x) [-beta*x(1)*x(3)/N;
    beta*x(1)*x(3)/N - alpha*x(2);
    alpha*x(2) - gamma*x(3) - delta*((1-kappaOld)*NOld + (1-kappa)*(1-NOld))*x(3);
    gamma*x(3);
    delta*((1-kappaOld)*NOld + (1-kappa)*(1-NOld))*x(3)];
[~,pos] = ode45( nonlinearFun,tSpan,[S0 E0 I0 R0 D0] );

if flag == 1
    F = pos;
elseif flag == 2
    F = pos(:,[3 5]);
end

